/* types.h */


#ifndef _TYPES_H
#define _TYPES_H

#include <stdio.h>

typedef int (*Compare)(void *, void *);
     /* this is the function prototype called to compare two objects
	It returns -1, 0 or 1, depending on their ordering */
typedef void * (*Kill)(void *);
     /* a generic destructor */
typedef int (*Read)(FILE *, void **);
     /* the function reading an object from a file.
	It stores the read object at the second argument */
typedef void (*Write)(FILE *, void *);
     /* the function writing an object from a file.
	It stores in the file the object given as second argument */
typedef void * (*Itis)(void *, void *);
     /* a function called when two objects are identical; it decides 
	which one object should remain, and returns a pointer to it. */

#endif


